%*************************************************************
%   Name:       Xueyan Li
%   Course:     CIS 581
%   Instructor: Longin Jan Latecki
%   File name:  movingColorBall.m
%*************************************************************

%read bmp file
ballBMP = imread('colorball.bmp');

framesPerSec = 25;
numerOfFrames = 250; 

% Create a new AVI file named "colorball.avi"
% Compression value is set to Indeo5 for Windows
aviobj = avifile('colorball.avi','fps', framesPerSec, 'COMPRESSION', 'Indeo5'); 

%Add the first frame
frame = im2frame(ballBMP);
aviobj = addframe(aviobj,frame);
 
%Prepare for the rest frames
for i=1:numerOfFrames
    
    % find color ball
    [ballRow, ballCol] = find( ballBMP==0 );
      
    %Clear the color ball
    for j=1:size(ballRow,1)        
        ballBMP(ballRow(j), ballCol(j)) = 255;
    end
    
    %Move the ball
    if( i<=55 )
        % move up
        newballRow = ballRow - 1;
    elseif( i>55 & i<=161 )
        % move down
        newballRow = ballRow + 1;
    elseif( i>161 ) 
        % move up
        newballRow = ballRow - 1;  
    end
    
    if( i<=125 )
        % move right
        newballCol = ballCol + 2;
    elseif( i>125 & i<=250 )
        % move left
        newballCol = ballCol - 2;
    end
           
    %Redraw the ball at new location
    for m=1:size(newballRow, 1)
        ballBMP( newballRow(m), newballCol(m) ) = 0;
    end
    
   
    %Converts the image into movie frame
    frame = im2frame(ballBMP);  
    
    % Add frame to avi file
    aviobj = addframe(aviobj,frame);  
end 

% close movie file 
aviobj = close(aviobj); 


